Index: client/socket.h
===================================================================
RCS file: /var/cvsroot/streamdev/client/socket.h,v
retrieving revision 1.3
diff -u -r1.3 socket.h
--- client/socket.h	8 Feb 2005 17:22:35 -0000	1.3
+++ client/socket.h	23 Apr 2007 17:04:14 -0000
@@ -47,6 +47,7 @@
 	bool CheckConnection(void);
 	bool ProvidesChannel(const cChannel *Channel, int Priority);
 	bool CreateDataConnection(eSocketId Id);
+	bool CloseDataConnection(eSocketId Id);
 	bool SetChannelDevice(const cChannel *Channel);
 	bool SetPid(int Pid, bool On);
 #if VDRVERSNUM >= 10300
Index: client/socket.c
===================================================================
RCS file: /var/cvsroot/streamdev/client/socket.c,v
retrieving revision 1.7
diff -u -r1.7 socket.c
--- client/socket.c	15 Jan 2007 11:45:48 -0000	1.7
+++ client/socket.c	23 Apr 2007 17:04:14 -0000
@@ -215,6 +215,24 @@
 	return true;
 }
 
+bool cClientSocket::CloseDataConnection(eSocketId Id) {
+	//if (!CheckConnection()) return false;
+
+	CMD_LOCK;
+
+	if(Id == siLive || Id == siLiveFilter)
+		if (m_DataSockets[Id] != NULL) {
+			std::string command = (std::string)"ABRT " + (const char*)itoa(Id);
+			if (!Command(command, 220)) {
+				if (errno == 0)
+					esyslog("ERROR: Streamdev: Couldn't cleanly close data connection");
+				//return false;
+			}		
+			DELETENULL(m_DataSockets[Id]);
+		}
+	return true;
+}
+
 bool cClientSocket::SetChannelDevice(const cChannel *Channel) {
 	if (!CheckConnection()) return false;
 
